# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictStr, constr, validator

class DateOrDiaryEntry(BaseModel):
    """
    DateOrDiaryEntry
    """
    var_date: Optional[StrictStr] = Field(None, alias="date", description="A date. If specified, DiaryEntry must not be specified.")
    diary_entry: Optional[constr(strict=True, max_length=64, min_length=1)] = Field(None, alias="diaryEntry", description="The code of a diary entry. If specified, Date must not be specified.")
    __properties = ["date", "diaryEntry"]

    @validator('diary_entry')
    def diary_entry_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if value is None:
            return value

        if not re.match(r"^[a-zA-Z0-9\-_]+$", value):
            raise ValueError(r"must validate the regular expression /^[a-zA-Z0-9\-_]+$/")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DateOrDiaryEntry:
        """Create an instance of DateOrDiaryEntry from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if var_date (nullable) is None
        # and __fields_set__ contains the field
        if self.var_date is None and "var_date" in self.__fields_set__:
            _dict['date'] = None

        # set to None if diary_entry (nullable) is None
        # and __fields_set__ contains the field
        if self.diary_entry is None and "diary_entry" in self.__fields_set__:
            _dict['diaryEntry'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DateOrDiaryEntry:
        """Create an instance of DateOrDiaryEntry from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DateOrDiaryEntry.parse_obj(obj)

        _obj = DateOrDiaryEntry.parse_obj({
            "var_date": obj.get("date"),
            "diary_entry": obj.get("diaryEntry")
        })
        return _obj
