# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictBool

class HoldingContext(BaseModel):
    """
    Holding context node.  Contains settings that control how LUSID handles holdings within portfolios.  # noqa: E501
    """
    tax_lot_level_holdings: Optional[StrictBool] = Field(None, alias="taxLotLevelHoldings", description="Whether or not to expand the holdings to return the underlying tax-lots. Defaults to True.")
    __properties = ["taxLotLevelHoldings"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> HoldingContext:
        """Create an instance of HoldingContext from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> HoldingContext:
        """Create an instance of HoldingContext from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return HoldingContext.parse_obj(obj)

        _obj = HoldingContext.parse_obj({
            "tax_lot_level_holdings": obj.get("taxLotLevelHoldings")
        })
        return _obj
