# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, conlist
from lusid.models.access_metadata_value import AccessMetadataValue

class UpsertPersonAccessMetadataRequest(BaseModel):
    """
    UpsertPersonAccessMetadataRequest
    """
    metadata: Optional[conlist(AccessMetadataValue)] = Field(None, description="The access control metadata to assign to a Person that matches the identifier")
    __properties = ["metadata"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpsertPersonAccessMetadataRequest:
        """Create an instance of UpsertPersonAccessMetadataRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in metadata (list)
        _items = []
        if self.metadata:
            for _item in self.metadata:
                if _item:
                    _items.append(_item.to_dict())
            _dict['metadata'] = _items
        # set to None if metadata (nullable) is None
        # and __fields_set__ contains the field
        if self.metadata is None and "metadata" in self.__fields_set__:
            _dict['metadata'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpsertPersonAccessMetadataRequest:
        """Create an instance of UpsertPersonAccessMetadataRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpsertPersonAccessMetadataRequest.parse_obj(obj)

        _obj = UpsertPersonAccessMetadataRequest.parse_obj({
            "metadata": [AccessMetadataValue.from_dict(_item) for _item in obj.get("metadata")] if obj.get("metadata") is not None else None
        })
        return _obj
