# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field
from lusid.models.structured_result_data import StructuredResultData
from lusid.models.structured_result_data_id import StructuredResultDataId

class UpsertStructuredResultDataRequest(BaseModel):
    """
    The details of the structured unit result data item to upsert into Lusid.  # noqa: E501
    """
    id: StructuredResultDataId = Field(...)
    data: Optional[StructuredResultData] = None
    __properties = ["id", "data"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UpsertStructuredResultDataRequest:
        """Create an instance of UpsertStructuredResultDataRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of id
        if self.id:
            _dict['id'] = self.id.to_dict()
        # override the default output from pydantic by calling `to_dict()` of data
        if self.data:
            _dict['data'] = self.data.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UpsertStructuredResultDataRequest:
        """Create an instance of UpsertStructuredResultDataRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UpsertStructuredResultDataRequest.parse_obj(obj)

        _obj = UpsertStructuredResultDataRequest.parse_obj({
            "id": StructuredResultDataId.from_dict(obj.get("id")) if obj.get("id") is not None else None,
            "data": StructuredResultData.from_dict(obj.get("data")) if obj.get("data") is not None else None
        })
        return _obj
